//+------------------------------------------------------------------+
//|                                             Trend_Percentage.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern string  TimeFrame        = "Current time frame";
extern int Length=10;
extern int Price=0;      // Applied price
                         // 0 - Close
                         // 1 - Open
                         // 2 - High
                         // 3 - Low
                         // 4 - Median
                         // 5 - Typical
                         // 6 - Weighted  

double Bulls[], Bears[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

int init()
{
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(0,Bulls);
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(1,Bears);
 indicatorFileName = WindowExpertName();
 returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
 timeFrame         = stringToTimeFrame(TimeFrame);
 IndicatorShortName(timeFrameToString(timeFrame)+"  Trend Percentage");
 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Bulls[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);              
                   Bulls[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,0,y);
                   Bears[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,1,y);
                   
               }
               return(0);
            }
 if(Bars<=Length) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double SBull, SBear;
 double Sum;
 double Pr0, Pr1;
 pos=limit;
 while(pos>=0)
 {
  SBull=0;
  SBear=0;
  for (i=1;i<=Length;i++)
  {
   Pr0=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+i);
   Pr1=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+i+1);
   if (Pr0>Pr1)
   {
    SBull=SBull+MathAbs(Pr0-Pr1);
   }
   else
   {
    if (Pr0<Pr1)
    {
     SBear=SBear+MathAbs(Pr0-Pr1);
    }
   }
  }
  Sum=SBull+SBear;
  if (Sum>0)
  {
   Bulls[pos]=100*SBull/Sum;
   Bears[pos]=100*SBear/Sum;
  }
  pos--;
 } 
 return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

